// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
var app = angular.module('game', ['ionic', 'ui.bootstrap', 'ngAnimate'])

    .run(function ($ionicPlatform) {
       /* $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            console.log('test23')
            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            }
            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                StatusBar.styleDefault();
            }
        });*/
    })

    .config(function ($stateProvider, $urlRouterProvider) {

        // Ionic uses AngularUI Router which uses the concept of states
        // Learn more here: https://github.com/angular-ui/ui-router
        // Set up the various states which the app can be in.
        // Each state's controller can be found in controllers.js
        $stateProvider

            // setup an abstract state for the tabs directive
            .state('tab', {
                url: "/tab",
                abstract: true,
                templateUrl: "partials/tabs.html"
            })

            // Each tab has its own nav history stack:

            .state('tab.characters', {
                url: '/characters',
                views: {
                    'tab-characters': {
                        templateUrl: 'partials/characters.html',
                        controller: 'CharactersCtrl'
                    }
                }
            })

            .state('tab.hunt', {
                url: '/hunt',
                views: {
                    'tab-hunt': {
                        templateUrl: 'partials/hunt.html',
                        controller: 'HuntCtrl'
                    }
                }
            })
            .state('tab.quests', {
                url: '/quests',
                views: {
                    'tab-quests': {
                        templateUrl: 'partials/quests.html',
                        controller: 'QuestsCtrl'
                    }
                }
            })
            .state('tab.shop', {
                url: '/shop',
                views: {
                    'tab-shop': {
                        templateUrl: 'partials/shop.html',
                        controller: 'ShopCtrl'
                    }
                }
            })

            .state('tab.dungeon', {
                url: '/dungeon',
                views: {
                    'tab-dungeon': {
                        templateUrl: 'partials/dungeon.html',
                        controller: 'DungeonCtrl'
                    }
                }
            })

            .state('tab.legacy', {
                url: '/legacy',
                views: {
                    'tab-legacy': {
                        templateUrl: 'partials/legacy.html',
                        controller: 'LegacyCtrl'
                    }
                }
            })

            .state('tab.inventory', {
                url: '/inventory',
                views: {
                    'tab-inventory': {
                        templateUrl: 'partials/inventory.html',
                        controller: 'InventoryCtrl'
                    }
                }
            })
            .state('tab.rating', {
                url: '/rating',
                views: {
                    'tab-rating': {
                        templateUrl: 'partials/rating.html',
                        controller: 'RatingCtrl'
                    }
                }
            });


        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/tab/characters');

    });

