app.controller('CharactersCtrl', ['$scope', '$state', 'Player', 'Characters', 'Modal', 'Skills', 'Balance',
    function ($scope, $state, Player, Characters, Modal, Skills, Balance) {

        $scope.setCurrentCharacter = function (id) {
            $scope.id = id;
        };

        $scope.createCharacter = function (name) {
            if (name.length >= 12) {
                $scope.errorMsg = "error12";
                return;
            }
            if (name.length <= 3) {
                $scope.errorMsg = "error3";
                return;
            }

            if (Player.get()[Balance.get().player.newCharCost[Characters.getLength() + 1].type]
                < Balance.get().player.newCharCost[Characters.getLength() + 1].cost) {
                return
            } else {
                if (Balance.get().player.newCharCost[Characters.getLength() + 1].type == 'gold') {
                    Player.takeGold(Balance.get().player.newCharCost[Characters.getLength() + 1].cost)
                } else {
                    Player.takeCrystals(Balance.get().player.newCharCost[Characters.getLength() + 1].cost)
                }
            }
            Player.addCharacter(
                $scope.id = Characters.createCharacter(name, Player.get().id).id
            );
            Player.newQuests();
            $scope.modalCreate.hide();
        };

        $scope.createModal = function (clickClose) {
            Modal.open('partials/modal/createCharacter.html', $scope, clickClose).then(
                function (modal) {
                    $scope.modalCreate = modal;
                    $scope.modalCreate.show();
                }
            );
        };

        $scope.showSkills = function () {
            Modal.open('partials/modal/skills.html', $scope).then(
                function (modal) {
                    $scope.modalSkills = modal;
                    $scope.modalSkills.show();
                }
            );
        };

        $scope.chooseWeapon = function () {
            Modal.open('partials/modal/chooseItem.html', $scope).then(
                function (modal) {
                    $scope.modalItems = modal;
                    $scope.chooseType = 'Weapon';
                    $scope.choosebleItems = Player.getWeapons();
                    $scope.modalItems.show();
                }
            );
        };

        $scope.chooseArmor = function () {
            Modal.open('partials/modal/chooseItem.html', $scope).then(
                function (modal) {
                    $scope.modalItems = modal;
                    $scope.chooseType = 'Armor';
                    $scope.choosebleItems = Player.getArmors();
                    $scope.modalItems.show();
                }
            );
        };


        $scope.presentedStats = [
            {
                name: "Ловкость",
                id: "agility"
            },
            {
                name: "Выносливость",
                id: "vitality"
            },
            {
                name: "Мудрость",
                id: "wisdom"
            },
            {
                name: "Интелект",
                id: "intellect"
            }
        ];

        $scope.goLegacy = function () {
            $state.go('tab.legacy');
        };

        $scope.goRating = function () {
            $state.go('tab.rating');
        };

        $scope.id = Player.get().characters[0];

        $scope.getReqExp = Characters.getReqExp;
        $scope.addStat = Characters.addStat;
        $scope.getHp = Characters.getHp;
        $scope.getMp = Characters.getMp;
        $scope.learnSkill = Characters.learnSkill;
        $scope.isLearnableSkill = Characters.isLearnableSkill;

        $scope.getByType = Skills.getByType;

        $scope.selectedSkills = 'active';


        if (Player.get().characters.length <= 0) {
            $scope.createModal(false)
        }

        //Characters.addExp(Characters.getIdByOrder(1), 1000000000000)
    }]);