app.controller('HuntCtrl', ['$rootScope', '$scope', '$state', '$interval', 'Monsters', 'Battle', 'Player', 'Modal', 'Characters',
    function ($rootScope, $scope, $state, $interval, Monsters, Battle, Player, Modal, Characters) {
        $scope.getByGrade = Monsters.getByGrade;
        $scope.grades = Monsters.getGrades();
        $scope.setMGrade = function (grade) {
            $scope.selectedMGrade.m_lvl = grade
        };
        $scope.enoughLevel = function (grade) {
            var max = Characters.getMaxLevel();
            var enoughLevel = false;
            if (parseInt(grade) <= max) {
                enoughLevel = true;
            }
            return enoughLevel
        };
        $scope.selectedMGrade = Player.getSelected();

        $scope.battle = Battle;
        $scope.startHunt = function (id) {
            Battle.start(id, Player.getCharacters());
            $scope.createBattleModal()
        };

        $scope.addCharacter = function () {
            Modal.open('partials/modal/chooseCharacter.html', $scope).then(
                function (modal) {
                    $scope.modalCharacter = modal;
                    $scope.modalCharacter.show();
                }
            );
        };
        $scope.createBattleModal = function () {
            Modal.open('partials/modal/battle.html', $scope).then(
                function (modal) {
                    $scope.modalBattle = modal;
                    $scope.modalBattle.show();
                }
            );
        };

        $scope.goDungeon = function () {
            $state.go('tab.dungeon');
        };
        $scope.getDifficulty = function (id) {
            var p = Characters.getPoints();
            var m = Monsters.getPoints(id);
            if (p / m < 2) {
                return 'hard'
            }
            if (p / m < 5) {
                return 'normal'
            }

            return 'easy'
        };
    }]);