app.filter('niceNumber', function () {
    return function (num, precision) {
        if (isNaN(parseFloat(num)) || !isFinite(num)) {
            return '';
        }
        if (num < 1) return Math.floor(num);
        if (typeof precision === 'undefined') {
            precision = 0;
        }

        var units = ['', 'K', 'M', 'B', 'Z', 'aa', 'bb', 'cc', 'dd', 'ee'];
        var number = 0;

        if (num != 0) {
            number = Math.floor(Math.log(Math.abs(Math.round(num))) / Math.log(1000));
        }
        var n = (num / Math.pow(1000, Math.floor(number)));

        if ((n < 10) && (number > 0)) {
            precision = 1;
            if ((n.toFixed(1) - n.toFixed(0)) == 0) {
                precision = 0;
            }
        }
        return n.toFixed(precision) + units[number];
    };
});