app.factory('Balance', function () {
    var Items = {
        sellCost: 0.5,
        enchantCost: 0.1,
        enchantEfficiency: 0.1,
        reqLevel: {
            ba: 1,
            ex: 25,
            el: 40,
            ma: 65
        }
    };
    var Player = {
        starting: {
            gold: 150,
            crystals: 10
        },
        newCharCost: {
            1: {
                type: 'gold',
                cost: 0
            },
            2: {
                type: 'gold',
                cost: 100000
            },
            3: {
                type: 'crystals',
                cost: 180
            },
            4: {
                type: 'crystals',
                cost: 1200
            },
            5: {
                type: 'crystals',
                cost: 7500
            },
            6: {
                type: 'crystals',
                cost: 32000
            },
            7: {
                type: 'crystals',
                cost: 99999
            }
        }
    };
    var Character = {
        starting: {
            stats: {
                vitality: 0,
                agility: 0,
                wisdom: 0,
                intellect: 0
            },
            level: 1,
            statPoints: 1,
            skillPoints: 1,
            exp: 0,
            reqExp: 50
        },
        reqExpMultiplier: 1.7,
        levelUpStats: 1,
        levelUpSkills: 1
    };

    var Stats = {
        Effect: {
            vitality: 100,
            agility: 0.05,
            wisdom: 100,
            intellect: 0.05
        }
    };

    return {
        getCharacter: function (type) {
            if (type) return Character[type];
            else return Character;
        },
        getStats: function (type) {
            if (type) return Stats[type];
            else return Stats;
        },
        getPlayer: function (type) {
            if (type) return Player[type];
            else return Player;
        },
        getItems: function (type) {
            if (type) return Items[type];
            else return Items;
        },
        get: function () {
            return {
                stats: Stats,
                character: Character,
                player: Player,
                items: Items
            }
        }
    }
});
