app.factory('Battle', ['LocalStorage', 'Monsters', 'Utils', 'Characters', 'Player', '$interval', '$log', '$ionicLoading', '$rootScope', '$timeout', 'Skills', '$injector',
    function (LocalStorage, Monsters, Utils, Characters, Player, $interval, $log, $ionicLoading, $rootScope, $timeout, Skills, $injector) {
        var session = {};
        var m = {};
        var c = [];
        var effects = {};
        var stats = {};
        var taunts = {};
        var attacks = {};
        var defences = {};
        var hps = {};
        var mps = {};
        var isFast = false;
        var modal;
        var func = {
            loadSave: function () {
                var save = LocalStorage.getObject('battle', {
                    m: {},
                    c: [],
                    session: {}
                });
                session = save.session;
                m = save.m;
                c = save.c;
                //session.calcedTime = (new Date()).getTime() - 10000000;
                if (session.calcedTime) {
                    func.startBattle();
                } else {
                    $rootScope.appLoaded = true;
                }
            },
            save: function () {
                LocalStorage.setObject('battle', {
                    m: m,
                    c: c,
                    session: session
                });
            },
            setModal: function (m) {
                modal = m;
            },
            getModal: function () {
                return modal;
            },
            getMonster: function () {
                return m;
            },
            isAlive: function (id) {
                var result = false;
                for (var i = 0; i < c.length; i++) {
                    if ((c[i].id == id) && (c[i].alive == true)) result = true;
                }
                return result;
            },
            getCharacters: function (alive) {
                var result = [];

                for (var i = 0; i < c.length; i++) {
                    if ((alive == undefined) || (c[i].alive == alive)) result.push(c[i])
                }
                return result;
            },
            getSession: function () {
                return session;
            },
            setMonster: function (id) {
                if ((typeof id) == 'object') {
                    m = id;
                } else {
                    m = angular.copy(Monsters.getByName(id));
                }

                m.chp = m.hp;
                m.cmp = m.mp;

                m.a_debuf = 0;
                m.roots = [];
            },
            setCharacters: function (charsIds) {
                if (func.getCharacters(true).length <= 0) {
                    session.startTime = (new Date()).getTime();
                }

                for (var i = 0; i < charsIds.length; i++) {
                    var chars = func.getCharacters();
                    var flag = false;
                    for (var j = 0; j < chars.length; j++) {
                        if (chars[j].id == charsIds[i]) {
                            flag = true;
                            c[j].hp = Characters.getHp(charsIds[i]);
                            c[j].mp = Characters.getMp(charsIds[i]);
                            c[j].alive = true;
                        }
                    }
                    if (flag) break;

                    c.push({
                        id: charsIds[i],
                        hp: Characters.getHp(charsIds[i]),
                        mp: Characters.getMp(charsIds[i]),
                        gXp: 0,
                        tXp: 0,
                        alive: true
                    });
                }
            },
            setFast: function (fast) {
                func.resetCache();
                isFast = fast;
            },
            getFast: function () {
                return isFast
            },
            startBattle: function () {
                var step = 1000;
                var f = function () {
                    var time = ((new Date()).getTime() - session.calcedTime);
                    if ((time > step) && (time <= 10000)) {
                        session.calcedTime += step;
                        func.getResults()
                    }
                    if (time > 10000) {
                        func.setFast(true);

                        if (time > 70000000) {
                            session.calcedTime = (new Date()).getTime() - 70000000;
                        }
                        func.stopBattle();
                        while (((new Date()).getTime() - session.calcedTime) > step) {
                            session.calcedTime += step;
                            func.getResults()
                        }
                        func.setFast(false);

                        func.startBattle();
                    }
                    $rootScope.appLoaded = true;
                };
                session.calcedTime += step;
                func.getResults();
                session.battle = $interval(f, 500, 0, true)
            },
            stopBattle: function () {
                if (angular.isDefined(session.battle)) {
                    $interval.cancel(session.battle);
                    session.battle = undefined;
                }
            },
            start: function (id, charsIds) {
                func.stop();

                c = [];
                func.setMonster(id);
                func.setCharacters(charsIds);

                session.startTime = (new Date()).getTime();
                session.calcedTime = session.startTime;
                session.kills = 0;
                session.gold = 0;
                session.drop = {};

                func.resetCache();

                func.startBattle();
            },
            stop: function () {
                func.stopBattle();

                func.setMonster({});
                func.setCharacters([]);

                delete session.calcedTime;
                delete session.endTime;
            },
            getTime: function () {
                if (!session.endTime) return 0;
                return Math.round((session.endTime - session.startTime ) / 1000)
            },
            resetCache: function () {
                effects = {};
                stats = {};
                taunts = {};
                attacks = {};
                defences = {};
                hps = {};
                mps = {};
            },
            getEffect: function (id, name) {
                if ((!effects[id]) || (!effects[id][name])) {
                    if (!effects[id]) effects[id] = {};
                    effects[id][name] = Characters.getEffect(id, name);
                }
                return effects[id][name]
            },
            getStat: function (id, name) {
                if ((!stats[id]) || (!stats[id][name])) {
                    if (!stats[id]) stats[id] = {};
                    stats[id][name] = Characters.getStat(id, name);
                }
                return stats[id][name]
            },
            getTaunt: function (id) {
                if (!taunts[id]) {
                    taunts[id] = Characters.getTaunt(id);
                }
                return taunts[id]
            },
            getAttack: function (id) {
                if (!attacks[id]) {
                    attacks[id] = Characters.getAttack(id);
                }
                return attacks[id]
            },
            getDefence: function (id) {
                if (!defences[id]) {
                    defences[id] = Characters.getDefence(id);
                }
                return defences[id]
            },
            getHp: function (id) {
                if (!hps[id]) {
                    hps[id] = Characters.getHp(id);
                }
                return hps[id]
            },
            getMp: function (id) {
                if (!mps[id]) {
                    mps[id] = Characters.getMp(id);
                }
                return mps[id]
            },
            getResults: function () {
                var cAlive = func.getCharacters(true);

                function calcTaunt(i) {
                    var result = func.getTaunt(cAlive[i].id) / c.length;

                    for (var j = 0; j < cAlive.length; j++) {
                        if (j != i) result += (1 - func.getTaunt(cAlive[j].id)) / (cAlive.length * (cAlive.length - 1))
                    }
                    if (result > 1) result = 1;
                    if (result < 0) result = 0;

                    cAlive[i].taunt = result;
                    return result
                }

                function calcHeal(i) {
                    var heal = func.getEffect(cAlive[i].id, 'heal');
                    if (heal.length > 0) {
                        return {
                            heal_eff: heal[0].efficiency.heal * func.getStat(cAlive[i].id, 'intellect'),
                            heal_mp: heal[0].mp_cost
                        }
                    } else return false
                }

                function calcAttack(i) {
                    var attack = func.getAttack(cAlive[i].id);
                    var efficiency = 1;
                    for (var j = 0; j < cAlive.length; j++) {
                        var skills = func.getEffect(cAlive[j].id, 'all_attack');
                        for (var k = 0; k < skills.length; k++) {
                            efficiency += skills[k].efficiency['all_attack']
                        }
                    }
                    cAlive[i].attack = attack;
                    cAlive[i].extraAttack = attack * (efficiency - 1);
                    return attack * efficiency
                }

                function calcDefence(i) {
                    var defence = func.getDefence(cAlive[i].id);
                    var efficiency = 1;
                    for (var j = 0; j < cAlive.length; j++) {
                        var skills = func.getEffect(cAlive[j].id, 'all_defence');
                        for (var k = 0; k < skills.length; k++) {
                            efficiency += skills[k].efficiency['all_defence']
                        }
                    }
                    cAlive[i].defence = defence;
                    cAlive[i].extraDefence = defence * (efficiency - 1);
                    return defence * efficiency
                }

                function calcTdmg(i) {
                    var t = calcTaunt(i);
                    var d = calcDefence(i);
                    var result = 20 * (1 + m.a_debuf) * t * Math.pow((m.attack * t + 1) / (d + 1), 1 / 2);

                    // calc random
                    var min = -20;
                    var max = 20;

                    var lvl = m.abilities['spirit_strike'];
                    if (lvl) {
                        var skill = Skills.getByName('spirit_strike');
                        if (m.cmp >= skill.mp_cost) {
                            m.cmp -= skill.mp_cost;
                            max += lvl * skill.efficiency['max_dmg'] * 100;
                        }
                    }

                    cAlive[i].min_def = Math.round(result + result * min / 100);
                    cAlive[i].max_def = Math.round(result + result * max / 100);

                    var rand = min - 0.5 + Math.random() * (max - min + 1);
                    rand = Math.round(rand);
                    result = result + result * rand / 100;
                    result = Math.round(result);
                    //

                    if (result < 0)  result = 0;

                    cAlive[i].def = result;
                    return result
                }

                function calcDmg(i) {
                    var a = calcAttack(i);
                    var d = m.defence;
                    //
                    var skills = func.getEffect(cAlive[i].id, 'monster_defence');
                    for (var k = 0; k < skills.length; k++) {
                        d += skills[k].efficiency['monster_defence']
                    }
                    //
                    if (d < 0) d = 0;
                    var result = 20 * Math.pow((a + 1) / (d + 1), 1 / 2);
                    //poison
                    var skills = func.getEffect(cAlive[i].id, 'damage');
                    cAlive[i].attBuffed = false;
                    for (var k = 0; k < skills.length; k++) {
                        if ((skills[k].required_items[0])
                            && (Player.findItem(skills[k].required_items[0])[0])
                            && (skills[k].items_amount[skills[k].required_items[0]] <= Player.findItem(skills[k].required_items[0])[0].num)) {
                            result += result * skills[k].efficiency['damage'];
                            Player.deleteItem(Player.findItem(skills[k].required_items[0], true)[0], skills[k].items_amount[skills[k].required_items[0]]);
                            cAlive[i].attBuffed = true;
                        }
                    }
                    // calc random
                    var min = -20;
                    var max = 20;

                    var skills = func.getEffect(cAlive[i].id, 'max_dmg');
                    if (skills[0]) {
                        cAlive[i][skills[0].name_id] = 0;
                        if (checkMp(i, skills[0].mp_cost)) {
                            max += (skills[0].efficiency['max_dmg'] * 100);
                            cAlive[i].mp -= skills[0].mp_cost;
                            cAlive[i][skills[0].name_id] = max;
                        }
                    }
                    cAlive[i].min_dmg = Math.round(result + result * min / 100);
                    cAlive[i].max_dmg = Math.round(result + result * max / 100);

                    var rand = min - 0.5 + Math.random() * (max - min + 1);
                    rand = Math.round(rand);
                    result = result + result * rand / 100;
                    result = Math.round(result);
                    //

                    if (result < 0) result = 0;

                    cAlive[i].dmg = result;
                    return result
                }

                function useMpPotion(i) {
                    var p = Player.findItem('mp_potion', true);
                    if (p.length) {
                        cAlive[i].mp = func.getMp(cAlive[i].id);
                        Player.deleteItem(p[0]);
                    }
                }

                function checkMp(i, mp) {
                    if (mp > cAlive[i].mp) useMpPotion(i);
                    return mp <= cAlive[i].mp
                }

                function changeHp(i, hp) {
                    cAlive[i].hp += hp;
                    if (hp > 0) Player.checkHeal(hp);
                }

                if (m.turnoff_debuff) {
                    m.a_debuf = 0;
                    m.turnoff_debuff = false;
                }
                if (cAlive.length <= 0) {
                    return;
                }

                session.endTime = session.calcedTime;

                // use mp potion
                for (var i = 0; i < cAlive.length; i++) {
                    if (cAlive[i].mp < 1) {
                        useMpPotion(i);
                    }
                }

                //try debuff monster attack
                if (m.a_debuf == 0) {
                    var best_eff = 0;
                    var best_debuffer = -1;
                    var item_id = 0;
                    var item_amount = 0;
                    for (var i = 0; i < cAlive.length; i++) {
                        var skills = func.getEffect(cAlive[i].id, 'all_monster_attack');
                        if ((skills.length > 0) && (skills[0].efficiency['all_monster_attack'] < best_eff)
                            && (Player.findItem(skills[0].required_items[0]).length)
                            && (Player.findItem(skills[0].required_items[0])[0].num >= skills[0].items_amount[skills[0].required_items[0]])) {
                            best_eff = skills[0].efficiency['all_monster_attack'];
                            best_debuffer = i;
                            item_id = Player.findItem(skills[0].required_items[0], true)[0];
                            item_amount = skills[0].items_amount[skills[0].required_items[0]];
                        }
                    }

                    if (best_eff < 0) {
                        m.a_debuf = best_eff;
                        Player.deleteItem(item_id, item_amount);
                    }
                }

                //roots
                for (var i = 0; i < cAlive.length; i++) {
                    var skills = func.getEffect(cAlive[i].id, 'turn_damage');
                    if (skills[0]) {
                        cAlive[i][skills[0].name_id] = 0;
                        if (checkMp(i, skills[0].mp_cost)) {
                            cAlive[i].mp -= skills[0].mp_cost;
                            m.roots.push({
                                sec: 7,
                                dmg: skills[0].efficiency['turn_damage'],
                                char: i
                            });
                        }
                    }
                }
                if (m.roots) {
                    for (var i = 0; i < m.roots.length; i++) {
                        m.roots[i].sec--;
                        m.chp -= m.roots[i].dmg;

                        cAlive[m.roots[i].char].roots += m.roots[i].dmg;

                        if (m.roots[i].sec == 0) m.roots.splice(i, 1)
                    }
                }

                //fireball
                for (var i = 0; i < cAlive.length; i++) {
                    var skills = func.getEffect(cAlive[i].id, 'magic_damage');
                    if (skills[0]) {
                        cAlive[i][skills[0].name_id] = 0;
                        if (checkMp(i, skills[0].mp_cost)) {
                            cAlive[i].mp -= skills[0].mp_cost;
                            m.chp -= skills[0].efficiency['magic_damage'] * func.getStat(cAlive[i].id, 'intellect');
                            cAlive[i][skills[0].name_id] = skills[0].efficiency['magic_damage'] * func.getStat(cAlive[i].id, 'intellect');
                        }
                    }
                }
                // damage to monster
                for (var i = 0; i < cAlive.length; i++) {
                    var d = calcDmg(i);
                    m.chp -= d;

                    var skills = func.getEffect(cAlive[i].id, 'life_steal');
                    var eff = 0;
                    for (var k = 0; k < skills.length; k++) {
                        eff += skills[k].efficiency['life_steal']
                    }
                    var ls = Math.round(eff * d);
                    cAlive[i].life_steal = ls;
                    changeHp(i, ls);
                }

                // calc taken damage
                for (var i = 0; i < cAlive.length; i++) {
                    var tdmg = calcTdmg(i);
                    changeHp(i, -tdmg);

                    //monster skill - vamp
                    m.life_steal = 0;
                    if (m.abilities['vampirism']) {
                        var vamp = tdmg * Skills.getByName('vampirism').efficiency['life_steal'] * m.abilities['vampirism'];
                        m.chp += vamp;
                        m.life_steal = vamp;
                        if (m.hp < m.chp) m.chp = m.hp
                    }


                    //return damage
                    var skills = func.getEffect(cAlive[i].id, 'return_damage');
                    cAlive[i]['spiked_armor'] = 0;
                    if (skills[0]) {
                        var r = Math.round(tdmg * skills[0].efficiency['return_damage']);
                        m.chp -= r;
                        cAlive[i][skills[0].name_id] = r;
                    }
                }

                // monster fireball
                m.fireball = 0;
                if (m.abilities['fireball']) {
                    var skill = Skills.getByName('fireball');
                    var req_mp = skill.mp_cost;
                    if (m.cmp >= req_mp) {
                        m.cmp -= req_mp;
                        for (var i = 0; i < cAlive.length; i++) {
                            var t = calcTaunt(i);
                            var dmg = t * m.abilities['fireball'] * 25;
                            m.fireball = dmg;
                            changeHp(i, -dmg)
                        }
                    }
                }

                // monster heal
                m.heal = 0;
                if (m.abilities['heal']) {
                    var req_mp = Skills.getByName('heal').mp_cost;
                    if (m.cmp >= req_mp) {
                        var heal_power = Math.pow(1 + m.abilities['heal'], 3) * 5;
                        if (((m.chp + heal_power) <= m.hp) || (m.chp <= 0)) {
                            m.cmp -= req_mp;
                            m.chp += heal_power;
                            m.heal = heal_power;
                        }
                    }
                    if (m.chp > m.hp) m.chp = m.hp;
                }

                // calc kill reward
                if (m.chp <= 0) {
                    session.kills++;
                    Player.checkKilling(m.name_id);
                    m.turnoff_debuff = true;
                    m.roots = [];
                    var rew = m.gold;
                    //
                    var best_eff = 0;
                    var best_opener = -1;
                    var item_id = 0;
                    var item_amount = 0;
                    for (var i = 0; i < cAlive.length; i++) {
                        if (m.name_id != 'dungeon_monster') {
                            var skills = func.getEffect(cAlive[i].id, 'gold_reward');
                            if ((skills.length > 0) && (skills[0].efficiency['gold_reward'] > best_eff)
                                && (Player.findItem(skills[0].required_items[0]).length)
                                && (Player.findItem(skills[0].required_items[0])[0].num >= skills[0].items_amount[skills[0].required_items[0]])) {
                                best_eff = skills[0].efficiency['gold_reward'];
                                best_opener = i;
                                item_id = Player.findItem(skills[0].required_items[0], true)[0];
                                item_amount = skills[0].items_amount[skills[0].required_items[0]];
                            }
                        }
                    }

                    if (best_eff > 0) {
                        rew += rew * best_eff;
                        Player.deleteItem(item_id, item_amount);
                    }

                    // items drop
                    for (var i = 0; i < m.drop.length; i++) {
                        var rnd = Math.random();
                        if (rnd <= m.drop[i].chance) {
                            Player.buyItem(m.drop[i].item, 1, true);
                            session.drop[m.drop[i].item] = (session.drop[m.drop[i].item] + 1) || 1
                        }
                    }
                    //
                    if (Player.addGold(rew)) session.gold += rew;
                    var g_xp = m.xp;

                    if (m.name_id != 'dungeon_monster') {
                        var stone_c = Player.findItem('exp_crystals', true);
                        if (stone_c.length) {
                            g_xp *= 12;
                            Player.deleteItem(stone_c[0]);
                        } else {
                            var stone_g = Player.findItem('exp_gold', true);
                            if (stone_g.length) {
                                g_xp *= 3;
                                Player.deleteItem(stone_g[0]);
                            }
                        }
                    }

                    g_xp *= (1 + 0.1 * Player.getStatue());

                    for (var i = 0; i < cAlive.length; i++) {
                        cAlive[i].gXp += g_xp / cAlive.length;
                        Characters.addExp(cAlive[i].id, g_xp / cAlive.length)
                    }
                    m.chp = m.hp;
                    m.cmp = m.mp;

                    if (m.name_id == 'dungeon_monster') {
                        func.stop();
                        $injector.get('Dungeon').nextLvl();
                        if (func.getModal()) {
                            func.getModal().hide();
                            func.getModal().remove();
                        }
                    }
                }


                var drink_hp_potion = true;

                //heal
                for (var i = 0; i < cAlive.length; i++) {
                    var h = calcHeal(i);
                    if (h) {
                        cAlive[i].heal = ' ';
                        if (checkMp(i, h.heal_mp)) {
                            var needHeal = false;
                            for (var j = 0; j < cAlive.length; j++) {
                                if ((cAlive[j].hp + h.heal_eff) <= func.getHp(cAlive[j].id)) needHeal = true;
                                if (cAlive[j].hp <= 0) needHeal = true;
                            }
                            if (needHeal) {
                                for (var j = 0; j < cAlive.length; j++) {
                                    var heal_power = h.heal_eff;
                                    if (func.getHp(cAlive[j].id) < heal_power) heal_power = func.getHp(cAlive[j].id);
                                    changeHp(j, heal_power);
                                }
                                cAlive[i].heal = h.heal_eff;
                                cAlive[i].mp -= h.heal_mp;
                            } else {
                                drink_hp_potion = false;
                            }
                        }
                    }
                }
                // use resurrection
                for (var i = 0; i < cAlive.length; i++) {
                    if (cAlive[i].hp <= 0) {
                        for (var j = 0; j < cAlive.length; j++) {
                            if (j != i) {
                                var skills = func.getEffect(cAlive[j].id, 'resurrection');
                                if (skills[0] && (checkMp(i, skills[0].mp_cost))) {
                                    var h = func.getHp(cAlive[i].id);
                                    cAlive[i].hp = h;
                                    cAlive[j].mp -= skills[0].mp_cost;
                                }
                            }
                        }
                    }
                }
                // use hp potion
                if (drink_hp_potion) {
                    for (var i = 0; i < cAlive.length; i++) {
                        if ((cAlive[i].hp <= 0) || ((cAlive[i].hp + 100) <= func.getHp(cAlive[i].id))) {
                            var p = Player.findItem('hp_potion', true);
                            if (p.length) {
                                changeHp(i, 100);
                                Player.deleteItem(p[0]);
                            }
                        }
                    }
                }
                // check death of characters
                for (var i = 0; i < cAlive.length; i++) {
                    if (cAlive[i].hp > func.getHp(cAlive[i].id)) cAlive[i].hp = func.getHp(cAlive[i].id);
                    if (cAlive[i].hp <= 0) {
                        cAlive[i].hp = 0;
                        if ((Characters.getReqExp(cAlive[i].id) / 10) > Characters.get()[cAlive[i].id].exp) {
                            cAlive[i].tXp += Characters.get()[cAlive[i].id].exp;
                        } else {
                            cAlive[i].tXp += Characters.getReqExp(cAlive[i].id) / 10;
                        }
                        Characters.takeExp(cAlive[i].id, Characters.getReqExp(cAlive[i].id) / 10);

                        cAlive[i].alive = false;
                    }
                }

            }
        };

        return func
    }]);