app.factory('Items', ['Utils', function (Utils) {
    var Items;
    var Weapons = {
        long_sword: {
            grade: 'ba',
            enchantable: true,
            icon: 'weapons/longsword2.png',
            attack: 45,
            defence: 30,
            stats: {},
            effects: {},
            cost: 36000
        },
        magic_staff: {
            grade: 'ba',
            enchantable: true,
            icon: 'weapons/staff.png',
            attack: 20,
            defence: 0,
            stats: {
                wisdom: 1,
                intellect: 1
            },
            effects: {},
            cost: 5000
        },
        common_dagger: {
            grade: 'ba',
            enchantable: true,
            icon: 'weapons/dagger.png',
            attack: 80,
            defence: 0,
            stats: {},
            effects: {},
            cost: 30000
        },
        wooden_staff: {
            grade: 'ba',
            enchantable: true,
            icon: 'weapons/wand.png',
            attack: 10,
            defence: 0,
            stats: {
                wisdom: 1
            },
            effects: {},
            cost: 20
        },
        short_sword: {
            grade: 'ba',
            enchantable: true,
            icon: 'weapons/shortsword.png',
            attack: 30,
            defence: 20,
            stats: {},
            effects: {},
            cost: 5000
        },
        axe: {
            grade: 'ba',
            enchantable: true,
            icon: 'weapons/Axe.png',
            attack: 25,
            defence: 0,
            stats: {},
            effects: {},
            cost: 20
        },
        bow: {
            grade: 'ba',
            enchantable: true,
            icon: 'weapons/bow.png',
            attack: 40,
            defence: 0,
            stats: {
                agility: 2
            },
            effects: {},
            cost: 5000
        },
        ex_rod: {
            grade: 'ex',
            enchantable: true,
            icon: 'weapons/ex_rod.png',
            attack: 35,
            defence: 0,
            stats: {
                intellect: 4,
                wisdom: 1
            },
            effects: {},
            cost: 3000000
        },
        ex_dagger: {
            grade: 'ex',
            enchantable: true,
            icon: 'weapons/ex_dagger-2.png',
            attack: 130,
            defence: 0,
            stats: {},
            effects: {},
            cost: 3500000
        },
        rapier: {
            grade: 'ex',
            enchantable: true,
            icon: 'weapons/ex_metal sword.png',
            attack: 95,
            defence: 50,
            stats: {},
            effects: {},
            cost: 4000000
        },
        ex_bow: {
            grade: 'ex',
            enchantable: true,
            icon: 'weapons/ex_longbow.png',
            attack: 115,
            defence: 10,
            stats: {
                agility: 5
            },
            effects: {},
            cost: 4500000
        },
        ex_staff: {
            grade: 'ex',
            enchantable: true,
            icon: 'weapons/ex_Wand2_1.png',
            attack: 50,
            defence: 10,
            stats: {
                wisdom: 4,
                intellect: 2
            },
            effects: {},
            cost: 5500000
        },
        ex_sword: {
            grade: 'ex',
            enchantable: true,
            icon: 'weapons/ex_Sword2.png',
            attack: 80,
            defence: 80,
            stats: {
                vitality: 1
            },
            effects: {},
            cost: 5500000
        },
        el_bow: {
            grade: 'el',
            enchantable: true,
            icon: 'weapons/el_greatbow.png',
            attack: 200,
            defence: 30,
            stats: {
                agility: 8,
                vitality: 1
            },
            effects: {},
            cost: 800000000
        },
        el_staff: {
            grade: 'el',
            enchantable: true,
            icon: 'weapons/el_greatstaff.png',
            attack: 65,
            defence: 25,
            stats: {
                wisdom: 6,
                intellect: 3
            },
            effects: {},
            cost: 800000000
        },
        el_sword: {
            grade: 'el',
            enchantable: true,
            icon: 'weapons/el_greatsword.png',
            attack: 170,
            defence: 90,
            stats: {
                agility: 1,
                vitality: 2
            },
            effects: {},
            cost: 800000000
        },
        el_hammer: {
            grade: 'el',
            enchantable: true,
            icon: 'weapons/el_Hammer1_3.png',
            attack: 160,
            defence: 130,
            stats: {
                vitality: 3
            },
            effects: {},
            cost: 1200000000
        },
        el_dagger: {
            grade: 'el',
            enchantable: true,
            icon: 'weapons/el_dagger-3.png',
            attack: 300,
            defence: 0,
            stats: {},
            effects: {},
            cost: 1200000000
        },
        ma_bow: {
            grade: 'ma',
            enchantable: true,
            icon: 'weapons/f8c3f08e03.jpg',
            attack: 350,
            defence: 50,
            stats: {
                agility: 12,
                vitality: 2
            },
            effects: {},
            cost: 100000000000
        },
        ma_staff: {
            grade: 'ma',
            enchantable: true,
            icon: 'weapons/799fbade54.jpg',
            attack: 95,
            defence: 45,
            stats: {
                wisdom: 10,
                intellect: 6
            },
            effects: {},
            cost: 100000000000
        },
        ma_sword: {
            grade: 'ma',
            enchantable: true,
            icon: 'weapons/aed2e698da.jpg',
            attack: 250,
            defence: 400,
            stats: {
                agility: 2,
                vitality: 3
            },
            effects: {},
            cost: 100000000000
        },
        ma_axe: {
            grade: 'ma',
            enchantable: true,
            icon: 'weapons/e93e718e7e.jpg',
            attack: 400,
            defence: 200,
            stats: {
                vitality: 5
            },
            effects: {},
            cost: 100000000000
        },
        ma_rod: {
            grade: 'ma',
            enchantable: true,
            icon: 'weapons/d20f5591e2.jpg',
            attack: 120,
            defence: 30,
            stats: {
                wisdom: 5,
                intellect: 15
            },
            effects: {},
            cost: 120000000000
        },
        ma_dagger: {
            grade: 'ma',
            enchantable: true,
            icon: 'weapons/798ec7b3eb.jpg',
            attack: 500,
            defence: 100,
            stats: {
                vitality: 1
            },
            effects: {},
            cost: 120000000000
        }
    };

    var Armors = {
        lather_armor: {
            grade: 'ba',
            enchantable: true,
            icon: 'armor/leather_armor.png',
            defence: 20,
            stats: {
                agility: 1
            },
            cost: 150
        },
        chain_armor: {
            grade: 'ba',
            enchantable: true,
            icon: 'armor/chain.jpg',
            defence: 30,
            stats: {},
            cost: 150
        },
        robe: {
            grade: 'ba',
            enchantable: true,
            icon: 'armor/robe.jpg',
            defence: 10,
            stats: {
                wisdom: 1
            },
            cost: 150
        },
        m_cloak: {
            grade: 'ba',
            enchantable: true,
            icon: 'armor/Cloak_03.png',
            defence: 20,
            stats: {
                intellect: 2
            },
            cost: 10000
        },
        iron_plate: {
            grade: 'ba',
            enchantable: true,
            icon: 'armor/61dfe50248.jpg',
            defence: 70,
            stats: {},
            cost: 30000
        },
        ranger: {
            grade: 'ba',
            enchantable: true,
            icon: 'armor/clothes.png',
            defence: 35,
            stats: {
                agility: 4
            },
            cost: 42000
        },
        metal_plate: {
            grade: 'ex',
            enchantable: true,
            icon: 'armor/metal_plate.png',
            defence: 90,
            stats: {
                vitality: 1,
                agility: 1
            },
            cost: 2000000
        },
        light_plate: {
            grade: 'ex',
            enchantable: true,
            icon: 'armor/LeatherArmor2.png',
            defence: 65,
            stats: {
                agility: 3
            },
            cost: 2500000
        },
        w_cloak: {
            grade: 'ex',
            enchantable: true,
            icon: 'armor/Cloak_02.png',
            defence: 50,
            stats: {
                wisdom: 3,
                intellect: 1
            },
            cost: 2500000
        },
        steel_armor: {
            grade: 'ex',
            enchantable: true,
            icon: 'armor/steel_armor.png',
            defence: 150,
            stats: {
                vitality: 3
            },
            cost: 3000000
        },
        dragon_armor: {
            grade: 'ex',
            enchantable: true,
            icon: 'armor/886378ad80.jpg',
            defence: 100,
            stats: {
                vitality: 1,
                agility: 2,
                wisdom: 1
            },
            cost: 3500000
        },
        frost_clothes: {
            grade: 'ex',
            enchantable: true,
            icon: 'armor/frost.jpg',
            defence: 75,
            stats: {
                intellect: 2,
                wisdom: 3
            },
            cost: 4000000
        },
        el_armor: {
            grade: 'el',
            enchantable: true,
            icon: 'armor/15d43b54a4.jpg',
            defence: 150,
            stats: {
                vitality: 3,
                agility: 2,
                wisdom: 1
            },
            cost: 500000000
        },
        wizard_clothes: {
            grade: 'el',
            enchantable: true,
            icon: 'armor/Mlwmk_croper_ru.png',
            defence: 90,
            stats: {
                vitality: 1,
                intellect: 3,
                wisdom: 3
            },
            cost: 500000000
        },
        el_glad: {
            grade: 'el',
            enchantable: true,
            icon: 'armor/fd9d6c9304.jpg',
            defence: 130,
            stats: {
                vitality: 1,
                agility: 6
            },
            cost: 700000000
        },
        el_fire: {
            grade: 'el',
            enchantable: true,
            icon: 'armor/fire.jpg',
            defence: 120,
            stats: {
                vitality: 3,
                intellect: 3,
                wisdom: 3
            },
            cost: 700000000
        },
        el_orc: {
            grade: 'el',
            enchantable: true,
            icon: 'armor/a8816611c9.jpg',
            defence: 180,
            stats: {
                vitality: 5,
                agility: 4
            },
            cost: 1200000000
        },
        knight_armor: {
            grade: 'ma',
            enchantable: true,
            icon: 'armor/1Xbeo_croper_ru.png',
            defence: 300,
            stats: {
                vitality: 8,
                agility: 7,
                wisdom: 3
            },
            cost: 85000000000
        },
        wizard_armor: {
            grade: 'ma',
            enchantable: true,
            icon: 'armor/oawzF_croper_ru.png',
            defence: 140,
            stats: {
                vitality: 5,
                intellect: 10,
                wisdom: 5
            },
            cost: 85000000000
        }
    };

    var Others = {
        hp_potion: {
            cost: 100,
            icon: 'health_potion.png',
            descId: 'hp_potion_desc',
            stackable: true
        },
        mp_potion: {
            cost: 800,
            icon: 'mana_potion.png',
            descId: 'mp_potion_desc',
            stackable: true
        },
        poison: {
            cost: 900,
            icon: 'pt3.png',
            descId: 'poison_desc',
            stackable: true
        },
        debuff_orb: {
            cost: 20,
            icon: 'Crystal Ball_02.png',
            descId: 'debuff_orb_desc',
            stackable: true
        },
        key: {
            cost: 10,
            icon: 'drill.png',
            descId: 'key_desc',
            stackable: true
        },
        exp_gold: {
            cost: 5000,
            icon: 'expGold.png',
            descId: 'exp_gold_desc',
            stackable: true
        },
        exp_crystals: {
            cost: 1,
            crystals: true,
            icon: 'expCrystals.png',
            descId: 'exp_crystals_desc',
            stackable: true
        }
    };

    var Enchants = {
        enchant_ba: {
            cost: 5000,
            grade: 'ba',
            icon: 'book-ancient.png',
            descId: 'enchant_ba_desc',
            stackable: true
        },
        enchant_ex: {
            cost: 200000,
            grade: 'ex',
            icon: 'book-spell.png',
            descId: 'enchant_ex_desc',
            stackable: true
        },
        enchant_el: {
            cost: 80000000,
            grade: 'el',
            icon: 'book-magic.png',
            descId: 'enchant_el_desc',
            stackable: true
        },
        enchant_ma: {
            cost: 5000000000,
            grade: 'ma',
            icon: 'book-arcane.png',
            descId: 'enchant_ma_desc',
            notTradable: true,
            stackable: true
        },
        enchant_random: {
            cost: 30,
            crystals: true,
            magic_chest: true,
            icon: 'Wrist_equipment_box.png',
            descId: 'enchant_random_desc',
            stackable: true
        }
    };

    return {
        get: function () {
            if (!Items) {
                Items = {};
                angular.extend(Items, Others, Armors, Weapons, Enchants);
            }
            return Items
        },
        getWeapons: function (grade) {
            if (grade) {
                var result = {};
                Utils.objectEach(Weapons, function (val) {
                    if (Weapons[val].grade == grade) {
                        result[val] = Weapons[val]
                    }
                })
            } else {
                return Weapons
            }
        },
        getArmors: function (grade) {
            if (grade) {
                var result = {};
                Utils.objectEach(Armors, function (val) {
                    if (Armors[val].grade == grade) {
                        result[val] = Armors[val]
                    }
                })
            } else {
                return Armors
            }
        },
        getOthers: function () {
            return Others
        },
        getEnchants: function () {
            return Enchants
        },
        getByName: function (name) {
            return this.get()[name]
        }
    }
}]);