app.factory('Monsters', ['Utils', function (Utils) {
    var Monsters = [
        {
            name_id: 'chickens',
            icon: 'chickens.png',
            attack: 5,
            defence: 10,
            hp: 100,
            mp: 0,
            xp: 10,
            gold: 10,
            abilities: {},
            drop: []
        },
        {
            name_id: 'boars',
            icon: 'boars.png',
            attack: 15,
            defence: 30,
            hp: 300,
            mp: 0,
            xp: 150,
            gold: 30,
            abilities: {},
            drop: []
        },
        {
            name_id: 'wolves',
            icon: 'wolves.png',
            attack: 60,
            defence: 20,
            hp: 200,
            mp: 0,
            xp: 250,
            gold: 40,
            abilities: {'vampirism': 6},
            drop: []
        },
        {
            name_id: 'bears',
            icon: 'bears.png',
            attack: 80,
            defence: 100,
            hp: 1000,
            mp: 0,
            xp: 2500,
            gold: 150,
            abilities: {},
            drop: []
        },
        {
            name_id: 'goblins',
            icon: 'a_Goblin.png',
            attack: 300,
            defence: 190,
            hp: 600,
            mp: 0,
            xp: 3700,
            gold: 50,
            abilities: {},
            drop: [{item: 'common_dagger', chance: 0.001}]
        },
        {
            name_id: 'rogues',
            icon: 'a_rogue.png',
            attack: 400,
            defence: 320,
            hp: 900,
            mp: 0,
            xp: 8000,
            gold: 550,
            abilities: {},
            drop: [{item: 'enchant_ba', chance: 0.01}, {item: 'bow', chance: 0.005}, {item: 'key', chance: 1}]
        },
        {
            name_id: 'hogor',
            icon: 'a_27d7801eb1.png',
            attack: 100,
            defence: 120,
            hp: 1400,
            mp: 100,
            xp: 10000,
            gold: 240,
            abilities: {heal: 4, fireball: 4},
            drop: [{item: 'mp_potion', chance: 0.2}]
        },
        {
            name_id: 'rats',
            icon: 'a_Ratman.png',
            attack: 310,
            defence: 220,
            hp: 4000,
            mp: 0,
            xp: 35000,
            gold: 100,
            abilities: {vampirism: 8},
            drop: []
        },
        {
            name_id: 'orcs',
            icon: 'a_Orc.png',
            attack: 550,
            defence: 700,
            hp: 5000,
            mp: 0,
            xp: 90000,
            gold: 350,
            abilities: {},
            drop: [{item: 'enchant_ba', chance: 0.05}, {item: 'iron_plate', chance: 0.005}]
        },
        {
            name_id: 'harpies',
            icon: 'a_Harpy.png',
            attack: 1000,
            defence: 180,
            hp: 3000,
            mp: 0,
            xp: 120000,
            gold: 150,
            abilities: {vampirism: 12},
            drop: []
        },
        {
            name_id: 'trolls',
            icon: 'a_Troll.png',
            attack: 600,
            defence: 650,
            hp: 12000,
            mp: 0,
            xp: 220000,
            gold: 300,
            abilities: {},
            drop: [{item: 'enchant_ba', chance: 0.2}, {item: 'enchant_ex', chance: 0.002}]
        },
        {
            name_id: 'lich',
            icon: 'a_Lichlord.png',
            attack: 300,
            defence: 350,
            hp: 2300,
            mp: 1000,
            xp: 100000,
            gold: 1100,
            abilities: {fireball: 10},
            drop: [{item: 'ex_rod', chance: 0.0005}, {item: 'mp_potion', chance: 0.5}]
        },
        {
            name_id: 'dragons_a',
            icon: 'a_dragon_a.png',
            attack: 800,
            defence: 2000,
            hp: 30000,
            mp: 5000,
            xp: 1000000,
            gold: 10000,
            abilities: {fireball: 12},
            drop: [{item: 'enchant_ex', chance: 0.05}, {item: 'w_cloak', chance: 0.001}, {
                item: 'light_plate',
                chance: 0.001
            }]
        },
        {
            name_id: 'naga',
            icon: 'a_Naga.png',
            attack: 1000,
            defence: 1000,
            hp: 15000,
            mp: 100,
            xp: 1200000,
            gold: 10000,
            abilities: {spirit_strike: 24},
            drop: [{item: 'debuff_orb', chance: 1}]
        },
        {
            name_id: 'prew',
            icon: 'a_Prew.png',
            attack: 6500,
            defence: 900,
            hp: 7000,
            mp: 0,
            xp: 550000,
            gold: 11000,
            abilities: {},
            drop: [{item: 'rapier', chance: 0.001}]
        },
        {
            name_id: 'lord',
            icon: 'a_16d1aea7d6.png',
            attack: 2000,
            defence: 2500,
            hp: 20000,
            mp: 0,
            xp: 2000000,
            gold: 40000,
            abilities: {vampirism: 16},
            drop: [{item: 'metal_plate', chance: 0.005}]
        },
        {
            name_id: 'keeper',
            icon: 'a_901aa87121.png',
            attack: 7000,
            defence: 2500,
            hp: 10000,
            mp: 5000,
            xp: 30000000,
            gold: 0,
            abilities: {fireball: 12, spirit_strike: 28},
            drop: []
        },
        {
            name_id: 'dragons_b',
            icon: 'a_06ec4fce77.png',
            attack: 1200,
            defence: 4000,
            hp: 50000,
            mp: 24000,
            xp: 8000000,
            gold: 50000,
            abilities: {heal: 20},
            drop: [{item: 'enchant_ex', chance: 0.1}, {item: 'enchant_el', chance: 0.001}]
        },
        {
            name_id: 'pain_knight',
            icon: 'a_LordofViolence.png',
            attack: 25000,
            defence: 100,
            hp: 100000,
            mp: 0,
            xp: 15000000,
            gold: 35000,
            abilities: {vampirism: 20},
            drop: [{item: 'el_glad', chance: 0.00005}]
        },
        {
            name_id: 'chaos',
            icon: 'a_DivineGuardian.png',
            attack: 10000,
            defence: 10000,
            hp: 35000,
            mp: 500,
            xp: 2000000,
            gold: 95000,
            abilities: {fireball: 12},
            drop: []
        },
        {
            name_id: 'undead',
            icon: '44839866f5.png',
            attack: 12000,
            defence: 17000,
            hp: 250000,
            mp: 0,
            xp: 30000000,
            gold: 150000,
            abilities: {},
            drop: []
        },
        {
            name_id: 'hound',
            icon: '5746c6e0a2.png',
            attack: 29000,
            defence: 10000,
            hp: 120000,
            mp: 0,
            xp: 25000000,
            gold: 100000,
            abilities: {vampirism: 20},
            drop: []
        },
        {
            name_id: 'necromancer',
            icon: 'efded489f2.png',
            attack: 3000,
            defence: 8000,
            hp: 80000,
            mp: 15000,
            xp: 10000000,
            gold: 30000,
            abilities: {fireball: 12, spirit_strike: 28},
            drop: [{item: 'enchant_el', chance: 0.0005}]
        },
        {
            name_id: 'ents',
            icon: 'a_Treefolk.png',
            attack: 20000,
            defence: 50000,
            hp: 2500000,
            mp: 100000,
            xp: 5000000000,
            gold: 750000,
            abilities: {heal: 20},
            drop: []
        },
        {
            name_id: 'dragon_c',
            icon: 'a_Dragon.png',
            attack: 75000,
            defence: 10000,
            hp: 1000000,
            mp: 0,
            xp: 1000000000,
            gold: 1700000,
            abilities: {},
            drop: [{item: 'enchant_el', chance: 0.01}, {item: 'enchant_ma', chance: 0.0001}]
        },
        {
            name_id: 'devil_a',
            icon: 'a_d1bd1bb337.png',
            attack: 50000,
            defence: 30000,
            hp: 1500000,
            mp: 60000,
            xp: 10000000000,
            gold: 1000000,
            abilities: {fireball: 12, vampirism: 20, spirit_strike: 28},
            drop: []
        }
    ];
    var Grades = [
        {
            name: '1+',
            points: 3000
        },
        {
            name: '20+',
            points: 30000
        },
        {
            name: '30+',
            points: 400000
        },
        {
            name: '40+',
            points: 1300000
        },
        {
            name: '50+',
            points: 11000000
        },
        {
            name: '60+',
            points: 120000000
        },
        {
            name: '70+',
            points: 9000000000000
        }
    ];
    var func = {
        get: function () {
            return Monsters
        },
        getGrades: function () {
            return Grades
        },
        getByName: function (nameId) {
            var named_monster = false;
            for (var i = 0; i < Monsters.length; i++) {
                if (Monsters[i].name_id == nameId) {
                    named_monster = Monsters[i];
                    break
                }
            }
            return named_monster
        },
        getPoints: function (nameId) {
            var m = this.getByName(nameId);
            return Math.round(Math.pow(m.attack * m.defence, 1 / 2) * (m.hp + m.mp) * 20 / 707);
        },
        getGrade: function (nameId) {
            var points = func.getPoints(nameId);
            for (var i = 0; i < Grades.length; i++) {
                if (Grades[i].points >= points) return Grades[i].name
            }
        },
        getByGrade: function (grade) {
            var graded_monsters = [];
            for (var i = 0; i < Monsters.length; i++) {
                if (func.getGrade(Monsters[i].name_id) == grade) {
                    graded_monsters.push(Monsters[i]);
                }
            }
            return graded_monsters
        }
    };
    return func
}]);