app.factory('Skills', function () {
    var Skills = [
        {
            name_id: 'stealth',
            class_ids: ['rogue'],
            icon: 'stealth',
            sp_cost: 1,
            required_level: 1,
            type: "group",
            ultimate: false,
            max_level: 10,
            effect: ['taunt'],
            efficiency: {
                taunt: -0.05
            },
            required_items: [],
            items_amount: {},
            mp_cost: 0
        },
        {
            name_id: 'luck',
            class_ids: ['rogue'],
            icon: 'luck',
            sp_cost: 1,
            required_level: 1,
            type: "group",
            ultimate: false,
            max_level: 25,
            effect: ['gold_reward'],
            efficiency: {
                gold_reward: 0.1
            },
            required_items: ['key'],
            items_amount: {
                key: 1
            },
            mp_cost: 0
        },
        {
            name_id: 'light_armor',
            class_ids: ['rogue'],
            icon: 'haste',
            sp_cost: 1,
            required_level: 1,
            type: "passive",
            ultimate: false,
            max_level: 15,
            effect: ['attack', 'defence'],
            efficiency: {
                attack: 0.1,
                defence: -0.02
            },
            required_items: [],
            items_amount: {},
            mp_cost: 0
        },
        {
            name_id: 'poisoned_blade',
            class_ids: ['rogue'],
            icon: 'poison',
            sp_cost: 5,
            required_level: 55,
            type: "ultimate",
            ultimate: true,
            max_level: 1,
            effect: ['damage'],
            efficiency: {
                damage: 1
            },
            required_items: ['poison'],
            items_amount: {
                poison: 1
            },
            mp_cost: 0
        },
        {
            name_id: 'weak_spot',
            class_ids: ['rogue'],
            icon: 'slice',
            sp_cost: 1,
            required_level: 1,
            type: "passive",
            ultimate: false,
            max_level: 25,
            effect: ['monster_defence'],
            efficiency: {
                monster_defence: -5
            },
            required_items: [],
            items_amount: {},
            mp_cost: 0
        },
        {
            name_id: 'taunt',
            class_ids: ['paladin'],
            icon: 'evil-eye',
            sp_cost: 1,
            required_level: 1,
            type: "group",
            ultimate: false,
            max_level: 20,
            effect: ['taunt'],
            efficiency: {
                taunt: 0.04
            },
            required_items: [],
            items_amount: {},
            mp_cost: 0
        },
        {
            name_id: 'resurrection',
            class_ids: ['paladin'],
            icon: 'wind-grasp',
            sp_cost: 5,
            required_level: 55,
            type: "ultimate",
            ultimate: true,
            max_level: 1,
            effect: ['resurrection'],
            efficiency: {
                resurrection: 1
            },
            required_items: [],
            items_amount: {},
            mp_cost: 50
        },
        {
            name_id: 'inspiration',
            class_ids: ['paladin'],
            icon: 'link',
            sp_cost: 1,
            required_level: 1,
            type: "group",
            ultimate: false,
            max_level: 20,
            effect: ['all_attack'],
            efficiency: {
                all_attack: 0.05
            },
            required_items: [],
            items_amount: {},
            mp_cost: 0
        },
        {
            name_id: 'shield_master',
            class_ids: ['paladin'],
            icon: 'protect',
            sp_cost: 1,
            required_level: 1,
            type: "passive",
            ultimate: false,
            max_level: 20,
            effect: ['attack', 'defence'],
            efficiency: {
                attack: -0.02,
                defence: 0.1
            },
            required_items: [],
            items_amount: {},
            mp_cost: 0
        },
        {
            name_id: 'heal',
            class_ids: ['priest'],
            icon: 'heal',
            sp_cost: 1,
            required_level: 1,
            type: "active",
            ultimate: false,
            max_level: 20,
            effect: ['heal'],
            efficiency: {
                heal: 5
            },
            required_items: [],
            items_amount: {},
            mp_cost: 5
        },
        {
            name_id: 'blessing_aura',
            class_ids: ['priest'],
            icon: 'light',
            sp_cost: 1,
            required_level: 1,
            type: "group",
            ultimate: false,
            max_level: 20,
            effect: ['all_defence'],
            efficiency: {
                all_defence: 0.05
            },
            required_items: [],
            items_amount: {},
            mp_cost: 0
        },
        {
            name_id: 'concentration',
            class_ids: ['priest'],
            icon: 'beam',
            sp_cost: 1,
            required_level: 1,
            type: "passive",
            ultimate: false,
            max_level: 25,
            effect: ['defence', 'attack', 'mp'],
            efficiency: {
                defence: -0.02,
                attack: -0.02,
                mp: 0.1
            },
            required_items: [],
            items_amount: {},
            mp_cost: 0
        },
        {
            name_id: 'attack_debuff',
            class_ids: ['priest'],
            icon: 'shielding',
            sp_cost: 1,
            required_level: 1,
            type: "active",
            ultimate: false,
            max_level: 10,
            effect: ['all_monster_attack'],
            efficiency: {
                all_monster_attack: -0.08
            },
            required_items: ['debuff_orb'],
            items_amount: {
                debuff_orb: 1
            },
            mp_cost: 0
        },
        {
            name_id: 'vampirism',
            class_ids: ['paladin'],
            icon: 'rip',
            sp_cost: 1,
            required_level: 1,
            type: "passive",
            ultimate: false,
            max_level: 20,
            effect: ['life_steal'],
            efficiency: {
                life_steal: 0.2
            },
            required_items: [],
            items_amount: {},
            mp_cost: 0
        },
        {
            name_id: 'spirit_strike',
            class_ids: ['paladin'],
            icon: 'enchant',
            sp_cost: 1,
            required_level: 1,
            type: "active",
            ultimate: false,
            max_level: 28,
            effect: ['max_dmg'],
            efficiency: {
                max_dmg: 0.2
            },
            required_items: [],
            items_amount: {},
            mp_cost: 2
        },
        {
            name_id: 'fireball',
            class_ids: ['priest'],
            icon: 'fireball',
            sp_cost: 1,
            required_level: 1,
            type: "active",
            ultimate: false,
            max_level: 12,
            effect: ['magic_damage'],
            efficiency: {
                magic_damage: 3
            },
            required_items: [],
            items_amount: {},
            mp_cost: 10
        },
        {
            name_id: 'roots',
            class_ids: ['priest'],
            icon: 'vines',
            sp_cost: 3,
            required_level: 1,
            type: "active",
            ultimate: false,
            max_level: 9,
            effect: ['turn_damage'],
            efficiency: {
                turn_damage: 50
            },
            required_items: [],
            items_amount: {},
            mp_cost: 100
        },
        {
            name_id: 'spiked_armor',
            class_ids: ['paladin'],
            icon: 'needles',
            sp_cost: 1,
            required_level: 1,
            type: "passive",
            ultimate: false,
            max_level: 15,
            effect: ['return_damage'],
            efficiency: {
                return_damage: 0.2
            },
            required_items: [],
            items_amount: {},
            mp_cost: 0
        }
    ];
    return {
        get: function () {
            return Skills
        },
        getByName: function (nameId) {
            var name_skill = false;
            for (var i = 0; i < Skills.length; i++) {
                if (Skills[i].name_id == nameId) {
                    name_skill = Skills[i];
                    break
                }
            }
            return name_skill
        },
        getByClass: function (classId) {
            var class_skills = [];
            for (var i = 0; i < Skills.length; i++) {
                if (Skills[i].class_ids.indexOf(classId) != -1) {
                    class_skills.push(Skills[i]);
                }
            }
            return class_skills
        },
        getByType: function (type) {
            var type_skills = [];
            for (var i = 0; i < Skills.length; i++) {
                if (Skills[i].type == type) {
                    type_skills.push(Skills[i]);
                }
            }
            return type_skills
        }
    }
});
